# -*- coding: utf-8 -*-
# -----------------------------------------------------------------------------
# Name:         alteration.py
# Purpose:      alteration class and methods
#
# Author:       Marco de Freitas
#
# Copyright:    Copyright © 2021 Marco de Freitas
#
# License:      GNU Lesser General Public License 3
# -----------------------------------------------------------------------------



"""
While loading musenot.dictionary module instanciates musenot objects. Those are usual music theory abstractions like
scales, chords Since it populates name space with a bunch of entities, the use of this module is optional,
and can be fine tune with commenting/uncommenting
"""
from musenot.abstervals import Absterval
from musenot.abscales import Abscale

# Abstervals
m2 = Absterval('b2')
M2 = Absterval('2')
A2 = Absterval('#2')

m3 = Absterval('b3')
M3 = Absterval('3')

D4 = Absterval('b4')
P4 = Absterval('4')
D4 = Absterval('#4')
D5 = Absterval('b5')
P5 = Absterval('5')
A5 = Absterval('#5')
m6 = Absterval('b6')
M6 = Absterval('6')
b7 = Absterval('b7')
M7 = Absterval('7')

# Abscales
Major = Abscale('2212221')
natural_minor = Abscale('2122122')
harmonic_minor = Abscale('2122131')
melodic_minor = Abscale('2122221')
harmonic_major = Abscale('2212131')
double_harmonic = Abscale('1312131')

# print(m3 + M3)
# print(Major)
# print(natural_minor)
# print(harmonic_minor)
# print(melodic_minor)
# print(harmonic_major)
# print(double_harmonic)
