import unittest

from musenot.alteration import *


class testAlterationsMethods(unittest.TestCase):

    def setUp(self):
        # init from string
        self.no_alteration = Alteration('')
        self.becarre = Alteration('♮')
        self.sharp = Alteration('#')
        self.double_sharp = Alteration('##')
        self.triple_sharp = Alteration('###')
        self.flat = Alteration('b')
        self.double_flat = Alteration('bb')
        self.triple_flat = Alteration('bbb')

        # init from alteration value
        self.no_alteration_numerical_init = Alteration(None)
        self.becarre_numerical_init = Alteration(0)
        self.sharp_numerical_init = Alteration(1)
        self.double_sharp_numerical_init = Alteration(2)
        self.triple_sharp_numerical_init = Alteration(3)
        self.flat_numerical_init = Alteration(-1)
        self.double_flat_numerical_init = Alteration(-2)
        self.triple_flat_numerical_init = Alteration(-3)

    def testAlterationsAttributs(self):
        self.assertEqual(self.no_alteration.label, '')
        self.assertEqual(self.no_alteration.value, 0)

        self.assertEqual(self.becarre.label, '')
        self.assertEqual(self.becarre.value, 0)

        self.assertEqual(self.sharp.label, '#')
        self.assertEqual(self.sharp.value, 1)

        self.assertEqual(self.double_sharp.label, '##')
        self.assertEqual(self.double_sharp.value, 2)

        self.assertEqual(self.triple_sharp.label, '###')
        self.assertEqual(self.triple_sharp.value, 3)

        self.assertEqual(self.flat.label, 'b')
        self.assertEqual(self.flat.value, -1)

        self.assertEqual(self.double_flat.label, 'bb')
        self.assertEqual(self.double_flat.value, -2)

        self.assertEqual(self.triple_flat.label, 'bbb')
        self.assertEqual(self.triple_flat.value, -3)

        self.assertEqual(self.no_alteration_numerical_init.label, '')
        self.assertEqual(self.no_alteration_numerical_init.value, 0)

        self.assertEqual(self.becarre_numerical_init.label, '')
        self.assertEqual(self.becarre_numerical_init.value, 0)

        self.assertEqual(self.sharp_numerical_init.label, '#')
        self.assertEqual(self.sharp_numerical_init.value, 1)

        self.assertEqual(self.double_sharp_numerical_init.label, '##')
        self.assertEqual(self.double_sharp_numerical_init.value, 2)

        self.assertEqual(self.triple_sharp_numerical_init.label, '###')
        self.assertEqual(self.triple_sharp_numerical_init.value, 3)

        self.assertEqual(self.flat_numerical_init.label, 'b')
        self.assertEqual(self.flat_numerical_init.value, -1)

        self.assertEqual(self.double_flat_numerical_init.label, 'bb')
        self.assertEqual(self.double_flat_numerical_init.value, -2)

        self.assertEqual(self.triple_flat_numerical_init.label, 'bbb')
        self.assertEqual(self.triple_flat_numerical_init.value, -3)

    def testAlterationMethods(self):
        self.no_alteration.alter(1)
        self.assertEqual(self.no_alteration.value, self.sharp.value)
        self.no_alteration.alter(-2)
        self.assertEqual(self.no_alteration.value, self.flat.value)
        self.no_alteration.alter(3)
        self.assertEqual(self.no_alteration.value, self.double_sharp.value)
        self.no_alteration.alter(-4)
        self.assertEqual(self.no_alteration.value, self.double_flat.value)

if __name__ == '__main__':
    unittest.main()
