# -*- coding: utf-8 -*-

import unittest

import sys
import os
sys.path.insert(0, os.path.abspath(os.path.join(os.path.dirname(__file__), '..')))

from musenot.notes import AbsNote


class testAbsnotesMethods(unittest.TestCase):
    
    def setUp(self):

        # init from string, unaltered notes
        self.absnote_a = AbsNote('a')
        self.absnote_b = AbsNote('b')
        self.absnote_c = AbsNote('c')
        self.absnote_d = AbsNote('d')
        self.absnote_e = AbsNote('e')
        self.absnote_f = AbsNote('f')
        self.absnote_g = AbsNote('g')

        # init from index , unaltered notes
        self.absnote_a_from_index = AbsNote('', 0, 0)
        self.absnote_b_from_index = AbsNote('', 1, 0)
        self.absnote_c_from_index = AbsNote('', 2, 0)
        self.absnote_d_from_index = AbsNote('', 3, 0)
        self.absnote_e_from_index = AbsNote('', 4, 0)
        self.absnote_f_from_index = AbsNote('', 5, 0)
        self.absnote_g_from_index = AbsNote('', 6, 0)

        # init from string, flattened notes
        self.absnote_a_flat = AbsNote('ab')
        self.absnote_b_flat = AbsNote('bb')
        self.absnote_c_flat = AbsNote('cb')
        self.absnote_d_flat = AbsNote('db')
        self.absnote_e_flat = AbsNote('eb')
        self.absnote_f_flat = AbsNote('fb')
        self.absnote_g_flat = AbsNote('gb')

        # init from string, sharpened notes
        self.absnote_a_sharp = AbsNote('a#')
        self.absnote_b_sharp = AbsNote('b#')
        self.absnote_c_sharp = AbsNote('c#')
        self.absnote_d_sharp = AbsNote('d#')
        self.absnote_e_sharp = AbsNote('e#')
        self.absnote_f_sharp = AbsNote('f#')
        self.absnote_g_sharp = AbsNote('g#')





    def testAbsnotesMethods(self):

        # Init methods
        self.assertEqual(self.absnote_a.name.label, 'a')
        self.assertEqual(self.absnote_a.indexInRefScale, 0)

        self.assertEqual(self.absnote_a_from_index.name.label, 'a')
        self.assertEqual(self.absnote_a_from_index.indexInRefScale, 0)

        self.assertEqual(self.absnote_b.name.label, 'b')
        self.assertEqual(self.absnote_b.indexInRefScale, 2)

        self.assertEqual(self.absnote_b_from_index.name.label, 'b')
        self.assertEqual(self.absnote_b_from_index.indexInRefScale, 2)

        self.assertEqual(self.absnote_c.name.label, 'c')
        self.assertEqual(self.absnote_c.indexInRefScale, 3)

        self.assertEqual(self.absnote_c_from_index.name.label, 'c')
        self.assertEqual(self.absnote_c_from_index.indexInRefScale, 3)

        self.assertEqual(self.absnote_d.name.label, 'd')
        self.assertEqual(self.absnote_d.indexInRefScale, 5)

        self.assertEqual(self.absnote_d_from_index.name.label, 'd')
        self.assertEqual(self.absnote_d_from_index.indexInRefScale, 5)

        self.assertEqual(self.absnote_e.name.label, 'e')
        self.assertEqual(self.absnote_e.indexInRefScale, 7)

        self.assertEqual(self.absnote_e_from_index.name.label, 'e')
        self.assertEqual(self.absnote_e_from_index.indexInRefScale, 7)

        self.assertEqual(self.absnote_f.name.label, 'f')
        self.assertEqual(self.absnote_f.indexInRefScale, 8)

        self.assertEqual(self.absnote_f_from_index.name.label, 'f')
        self.assertEqual(self.absnote_f_from_index.indexInRefScale, 8)

        self.assertEqual(self.absnote_g.name.label, 'g')
        self.assertEqual(self.absnote_g.indexInRefScale, 10)

        self.assertEqual(self.absnote_g_from_index.name.label, 'g')
        self.assertEqual(self.absnote_g_from_index.indexInRefScale, 10)




        self.assertEqual(self.absnote_a_sharp.__str__(), 'a#')
        self.assertEqual(self.absnote_a_sharp.indexInRefScale, 1)

        self.assertEqual(self.absnote_a_flat.__str__(), 'ab')
        self.assertEqual(self.absnote_a_flat.indexInRefScale, 11)

        self.assertEqual(self.absnote_b.name.label, 'b')
        self.assertEqual(self.absnote_b.indexInRefScale, 2)

        self.assertEqual(self.absnote_b_from_index.name.label, 'b')
        self.assertEqual(self.absnote_b_from_index.indexInRefScale, 2)

        self.assertEqual(self.absnote_c.name.label, 'c')
        self.assertEqual(self.absnote_c.indexInRefScale, 3)

        self.assertEqual(self.absnote_c_from_index.name.label, 'c')
        self.assertEqual(self.absnote_c_from_index.indexInRefScale, 3)

        self.assertEqual(self.absnote_d.name.label, 'd')
        self.assertEqual(self.absnote_d.indexInRefScale, 5)

        self.assertEqual(self.absnote_d_from_index.name.label, 'd')
        self.assertEqual(self.absnote_d_from_index.indexInRefScale, 5)

        self.assertEqual(self.absnote_e.name.label, 'e')
        self.assertEqual(self.absnote_e.indexInRefScale, 7)

        self.assertEqual(self.absnote_e_from_index.name.label, 'e')
        self.assertEqual(self.absnote_e_from_index.indexInRefScale, 7)

        self.assertEqual(self.absnote_f.name.label, 'f')
        self.assertEqual(self.absnote_f.indexInRefScale, 8)

        self.assertEqual(self.absnote_f_from_index.name.label, 'f')
        self.assertEqual(self.absnote_f_from_index.indexInRefScale, 8)

        self.assertEqual(self.absnote_g.name.label, 'g')
        self.assertEqual(self.absnote_g.indexInRefScale, 10)

        self.assertEqual(self.absnote_g_from_index.name.label, 'g')
        self.assertEqual(self.absnote_g_from_index.indexInRefScale, 10)



        # other methods
        self.assertTrue(self.absnote_a.is_enharmonic(self.absnote_a_from_index))
        self.assertTrue(self.absnote_a_sharp.is_enharmonic(self.absnote_b_flat))





if __name__ == '__main__':
    unittest.main()
